#ifndef MSUGCPGRID_H
#define MSUGCPGRID_H
#include <msucore.h>
#include <msupixeltransformer.h>
#include <ogrsf_frmts.h>
namespace msumr
{
class MSUPROJ_EXPORT GCPGrid
{
public:
    GCPGrid();
    GCPGrid(const GCPGrid &other);
    ~GCPGrid();
    bool isUtmNorthern() const;
    unsigned short utmZone() const;
    std::string utmZoneName() const;
    GCP *gcps() const;
    OGRSpatialReference srs() const;
    size_t size() const;
    double *geoTransform() const;
    size_t extentXSize() const;
    size_t extentYSize() const;
    bool fromFile(const std::string &path);
    bool toUtm();
    GCP *operator[] (const size_t &index) const;
    unsigned int xSize() const;
    unsigned int ySize() const;
    PixelTransformer *pixelTransformer() const;
private:
    enum COMPARE_COORDS
    {
        MIN_LON,
        MAX_LON,
        MIN_LAT,
        MAX_LAT
    };
    bool mUtmNorthern;
    unsigned short mUtmZone;
    GCP *mGcps;
    OGRSpatialReference mSrs;
    unsigned int mXSize;
    unsigned int mYSize;
    size_t mSize;
    size_t mExtentXSize;
    size_t mExtentYSize;
    double mGeoTransform[6];
    void pUpdateVars(bool utm = false);
};
}
#endif
